<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Buffer.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Buffer.hh</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Buffer.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="comment">// Copyright (C) 1997-2000 Shigeru Chiba</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line"><span class="comment">//</span></span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line">#ifndef Synopsis_Buffer_hh_</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line">#define Synopsis_Buffer_hh_</span>
<a id="line10"></a><span class="lineno">10</span>
<a id="line11"></a><span class="lineno">11</span><span class="line">#include &lt;streambuf&gt;</span>
<a id="line12"></a><span class="lineno">12</span><span class="line">#include &lt;vector&gt;</span>
<a id="line13"></a><span class="lineno">13</span>
<a id="line14"></a><span class="lineno">14</span><span class="line"><span class="keyword">namespace</span> <a href="../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line15"></a><span class="lineno">15</span><span class="line">{</span>
<a id="line16"></a><span class="lineno">16</span>
<a id="line17"></a><span class="lineno">17</span><span class="line"><span class="comment">//. Buffer holds the memory on top of which a parse tree / syntax tree is</span></span>
<a id="line18"></a><span class="lineno">18</span><span class="line"><span class="comment">//. constructed. Besides giving access to individual characters, it provides</span></span>
<a id="line19"></a><span class="lineno">19</span><span class="line"><span class="comment">//. the means to register replacements for buffer chunks, such that when</span></span>
<a id="line20"></a><span class="lineno">20</span><span class="line"><span class="comment">//. the Buffer's write method is executed the new file will contain the</span></span>
<a id="line21"></a><span class="lineno">21</span><span class="line"><span class="comment">//. modified source.</span></span>
<a id="line22"></a><span class="lineno">22</span><span class="line"><span class="keyword">class</span> <a href="../../Scopes/Synopsis/Buffer.html" title="class Synopsis::Buffer">Buffer</a></span>
<a id="line23"></a><span class="lineno">23</span><span class="line">{</span>
<a id="line24"></a><span class="lineno">24</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">  <a href="" title="member function Synopsis::Buffer::Buffer(std::streambuf*,const std::string&amp;)">Buffer</a>(<a href="" title="typedef std::streambuf">std::streambuf</a> *, <span class="keyword">const</span> <a href="" title="typedef std::string">std::string</a> &amp; = std::string(&quot;unknown&quot;));</span>
<a id="line26"></a><span class="lineno">26</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">  <span class="comment">//. return the size of the buffer</span></span>
<a id="line28"></a><span class="lineno">28</span><span class="line">  <span class="keyword">unsigned long</span> <a href="../../Scopes/Synopsis/Buffer.html#size_l_rconst" title="member function Synopsis::Buffer::size()const">size</a>() const { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Buffer.html#my_buffer" title="data member Synopsis::Buffer::my_buffer">my_buffer</a>.size();}</span>
<a id="line29"></a><span class="lineno">29</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">  <span class="comment">//. report the character at the current position and advance one character</span></span>
<a id="line31"></a><span class="lineno">31</span><span class="line">  <span class="keyword">char</span> <a href="../../Scopes/Synopsis/Buffer.html#get_l_r" title="member function Synopsis::Buffer::get()">get</a>() { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Buffer.html#my_cursor" title="data member Synopsis::Buffer::my_cursor">my_cursor</a> &lt; <a href="../../Scopes/Synopsis/Buffer.html#my_buffer" title="data member Synopsis::Buffer::my_buffer">my_buffer</a>.size() ? <a href="../../Scopes/Synopsis/Buffer.html#my_buffer" title="data member Synopsis::Buffer::my_buffer">my_buffer</a>[<a href="../../Scopes/Synopsis/Buffer.html#my_cursor" title="data member Synopsis::Buffer::my_cursor">my_cursor</a>++] : <span class="string">'\0'</span>;}</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">  <span class="comment">//. undo the last get</span></span>
<a id="line33"></a><span class="lineno">33</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Buffer.html#unget_l_r" title="member function Synopsis::Buffer::unget()">unget</a>() { --<a href="../../Scopes/Synopsis/Buffer.html#my_cursor" title="data member Synopsis::Buffer::my_cursor">my_cursor</a>;}</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">  <span class="comment">//. reset the current position to position c</span></span>
<a id="line35"></a><span class="lineno">35</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Buffer.html#reset_lunsigned.long_r" title="member function Synopsis::Buffer::reset(unsigned long)">reset</a>(<span class="keyword">unsigned long</span> c = 0) { <a href="../../Scopes/Synopsis/Buffer.html#my_cursor" title="data member Synopsis::Buffer::my_cursor">my_cursor</a> = <a href="" title="parameter c">c</a>;}</span>
<a id="line36"></a><span class="lineno">36</span>
<a id="line37"></a><span class="lineno">37</span><span class="line">  <span class="comment">//. report the current position</span></span>
<a id="line38"></a><span class="lineno">38</span><span class="line">  <span class="keyword">unsigned long</span> <a href="../../Scopes/Synopsis/Buffer.html#position_l_rconst" title="member function Synopsis::Buffer::position()const">position</a>() const { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Buffer.html#my_cursor" title="data member Synopsis::Buffer::my_cursor">my_cursor</a> - <span class="literal">1</span>;}</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">  <span class="comment">//. report the character at position p</span></span>
<a id="line40"></a><span class="lineno">40</span><span class="line">  <span class="keyword">char</span> <a href="../../Scopes/Synopsis/Buffer.html#at_lunsigned.long_rconst" title="member function Synopsis::Buffer::at(unsigned long)const">at</a>(<span class="keyword">unsigned long</span> p) const { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Buffer.html#my_buffer" title="data member Synopsis::Buffer::my_buffer">my_buffer</a>[<a href="" title="parameter p">p</a>];}</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">  <span class="comment">//. report the pointer at position p</span></span>
<a id="line42"></a><span class="lineno">42</span><span class="line">  <span class="keyword">const</span> <span class="keyword">char</span> *<a href="../../Scopes/Synopsis/Buffer.html#ptr_lunsigned.long_rconst" title="member function Synopsis::Buffer::ptr(unsigned long)const">ptr</a>(<span class="keyword">unsigned long</span> p = 0) const { <span class="keyword">return</span> <a href="../../Scopes/Synopsis/Buffer.html#my_buffer" title="data member Synopsis::Buffer::my_buffer">my_buffer</a>.c_str() + <a href="" title="parameter p">p</a>;}</span>
<a id="line43"></a><span class="lineno">43</span>
<a id="line44"></a><span class="lineno">44</span><span class="line">  <span class="comment">//. replace the text between from and to by the text between</span></span>
<a id="line45"></a><span class="lineno">45</span><span class="line"><span class="comment">  //. begin and begin + length</span></span>
<a id="line46"></a><span class="lineno">46</span><span class="line">  <span class="keyword">void</span> <a href="../../Scopes/Synopsis/Buffer.html#replace_lconst.char_S_cconst.char_S_cconst.char_S_cunsigned.long_r" title="member function Synopsis::Buffer::replace(const char*,const char*,const char*,unsigned long)">replace</a>(<span class="keyword">const</span> <span class="keyword">char</span> *from, <span class="keyword">const</span> <span class="keyword">char</span> *to,</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">	       <span class="keyword">const</span> <span class="keyword">char</span> *begin, <span class="keyword">unsigned long</span> length);</span>
<a id="line48"></a><span class="lineno">48</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">  <span class="comment">//. Return the origin of the given pointer (filename and line number)</span></span>
<a id="line50"></a><span class="lineno">50</span><span class="line">  <span class="keyword">unsigned long</span> <a href="" title="member function Synopsis::Buffer::origin(const char*,std::string&amp;)const">origin</a>(<span class="keyword">const</span> <span class="keyword">char</span> *, <a href="" title="typedef std::string">std::string</a> &amp;) const;</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">  <span class="comment">//. Write the buffer into the given output stream</span></span>
<a id="line52"></a><span class="lineno">52</span><span class="line"><span class="comment">  //. The first line contains a line directive issuing the input file name;</span></span>
<a id="line53"></a><span class="lineno">53</span><span class="line"><span class="comment">  //. if filename is non-empty, use this to fake another one.</span></span>
<a id="line54"></a><span class="lineno">54</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::Buffer::write(std::ostream&amp;,const std::string&amp;)const">write</a>(<a href="" title="typedef std::ostream">std::ostream</a> &amp;, <span class="keyword">const</span> <a href="" title="typedef std::string">std::string</a> &amp;) const;</span>
<a id="line55"></a><span class="lineno">55</span>
<a id="line56"></a><span class="lineno">56</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">  <span class="keyword">struct</span> <a href="../../Scopes/Synopsis/Buffer/Replacement.html" title="struct Synopsis::Buffer::Replacement">Replacement</a></span>
<a id="line58"></a><span class="lineno">58</span><span class="line">  {</span>
<a id="line59"></a><span class="lineno">59</span><span class="line">    <a href="../../Scopes/Synopsis/Buffer/Replacement.html#Replacement_lconst.char_S_cconst.char_S_cconst.char_S_cunsigned.long_r" title="member function Synopsis::Buffer::Replacement::Replacement(const char*,const char*,const char*,unsigned long)">Replacement</a>(<span class="keyword">const</span> <span class="keyword">char</span> *from, <span class="keyword">const</span> <span class="keyword">char</span> *to,</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">		<span class="keyword">const</span> <span class="keyword">char</span> *begin, <span class="keyword">unsigned long</span> length);</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">    static <span class="keyword">bool</span> <a href="../../Scopes/Synopsis/Buffer/Replacement.html#smaller_lconst.Replacement_A_cconst.Replacement_A_r" title="member function Synopsis::Buffer::Replacement::smaller(const Replacement&amp;,const Replacement&amp;)">smaller</a>(<a href="../../Scopes/Synopsis/Buffer/Replacement.html" title="struct Synopsis::Buffer::Replacement">Replacement const</a> &amp;r1, <a href="../../Scopes/Synopsis/Buffer/Replacement.html" title="struct Synopsis::Buffer::Replacement">Replacement const</a> &amp;r2)</span>
<a id="line62"></a><span class="lineno">62</span><span class="line">    { <span class="keyword">return</span> <a href="" title="parameter r1">r1</a>.<a href="../../Scopes/Synopsis/Buffer/Replacement.html#from" title="data member Synopsis::Buffer::Replacement::from">from</a> &lt; <a href="" title="parameter r2">r2</a>.<a href="../../Scopes/Synopsis/Buffer/Replacement.html#from" title="data member Synopsis::Buffer::Replacement::from">from</a>;}</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">    <span class="keyword">const</span> <span class="keyword">char</span>   *<a href="../../Scopes/Synopsis/Buffer/Replacement.html#from" title="data member Synopsis::Buffer::Replacement::from">from</a>;</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">    <span class="keyword">const</span> <span class="keyword">char</span>   *<a href="../../Scopes/Synopsis/Buffer/Replacement.html#to" title="data member Synopsis::Buffer::Replacement::to">to</a>;</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">    <span class="keyword">const</span> <span class="keyword">char</span>   *<a href="../../Scopes/Synopsis/Buffer/Replacement.html#begin" title="data member Synopsis::Buffer::Replacement::begin">begin</a>;</span>
<a id="line66"></a><span class="lineno">66</span><span class="line">    <span class="keyword">unsigned long</span> <a href="../../Scopes/Synopsis/Buffer/Replacement.html#length" title="data member Synopsis::Buffer::Replacement::length">length</a>;</span>
<a id="line67"></a><span class="lineno">67</span><span class="line">  };</span>
<a id="line68"></a><span class="lineno">68</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::vector">vector</a>&lt;<a href="../../Scopes/Synopsis/Buffer/Replacement.html" title="struct Synopsis::Buffer::Replacement">Replacement</a>&gt; <a href="../../Scopes/Synopsis/Buffer.html#Replacements" title="typedef Synopsis::Buffer::Replacements">Replacements</a>;</span>
<a id="line69"></a><span class="lineno">69</span>
<a id="line70"></a><span class="lineno">70</span><span class="line">  <span class="comment">//. read a line directive starting at position pos, and return</span></span>
<a id="line71"></a><span class="lineno">71</span><span class="line"><span class="comment">  //. the line number found. Also report the begin and end of the filename</span></span>
<a id="line72"></a><span class="lineno">72</span><span class="line"><span class="comment">  //. (with respect to the internal buffer).</span></span>
<a id="line73"></a><span class="lineno">73</span><span class="line"><span class="comment">  //. line is the default line number that gets reported on error (in</span></span>
<a id="line74"></a><span class="lineno">74</span><span class="line"><span class="comment">  //. which case begin and end remain unchanged)</span></span>
<a id="line75"></a><span class="lineno">75</span><span class="line">  <span class="keyword">long</span> <a href="../../Scopes/Synopsis/Buffer.html#read_line_directive_lunsigned.long_clong_cunsigned.long_A_cunsigned.long_A_rconst" title="member function Synopsis::Buffer::read_line_directive(unsigned long,long,unsigned long&amp;,unsigned long&amp;)const">read_line_directive</a>(<span class="keyword">unsigned long</span> cursor, <span class="keyword">long</span> line,</span>
<a id="line76"></a><span class="lineno">76</span><span class="line">			   <span class="keyword">unsigned long</span> &amp;begin, <span class="keyword">unsigned long</span> &amp;end) const;</span>
<a id="line77"></a><span class="lineno">77</span>
<a id="line78"></a><span class="lineno">78</span><span class="line">  <a href="" title="typedef std::string">std::string</a>   <a href="../../Scopes/Synopsis/Buffer.html#my_filename" title="data member Synopsis::Buffer::my_filename">my_filename</a>;</span>
<a id="line79"></a><span class="lineno">79</span><span class="line">  <a href="" title="typedef std::string">std::string</a>   <a href="../../Scopes/Synopsis/Buffer.html#my_buffer" title="data member Synopsis::Buffer::my_buffer">my_buffer</a>;</span>
<a id="line80"></a><span class="lineno">80</span><span class="line">  <span class="keyword">unsigned long</span> <a href="../../Scopes/Synopsis/Buffer.html#my_cursor" title="data member Synopsis::Buffer::my_cursor">my_cursor</a>;</span>
<a id="line81"></a><span class="lineno">81</span><span class="line">  <a href="../../Scopes/Synopsis/Buffer.html#Replacements" title="typedef Synopsis::Buffer::Replacements">Replacements</a>  <a href="../../Scopes/Synopsis/Buffer.html#my_replacements" title="data member Synopsis::Buffer::my_replacements">my_replacements</a>;</span>
<a id="line82"></a><span class="lineno">82</span><span class="line">};</span>
<a id="line83"></a><span class="lineno">83</span>
<a id="line84"></a><span class="lineno">84</span><span class="line">}</span>
<a id="line85"></a><span class="lineno">85</span>
<a id="line86"></a><span class="lineno">86</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:04 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
